



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux系统编程（27）——线程控制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux系统编程（27）——线程控制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 22:25:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>进程在各自独立的地址空间中运行，进程之间共享数据需要用mmap或者进程间通信机制，那么如何在一个进程的地址空间中执行多个线程呢。有些情况需要在一个进程中同时执行多个控制流程，这时候线程就派上了用场，比如实现一个图形界面的下载软件，一方面需要和用户交互，等待和处理用户的鼠标键盘事件，另一方面又需要同时下载多个文件，等待和处理从多个网络主机发来的数据，这些任务都需要一个“等待-处理”的循环，可以用多线程实现，一个线程专门负责与用户交互，另外几个线程每个线程负责和一个网络主机通信。</p>
<p>main函数和信号处理函数是同一个进程地址空间中的多个控制流程，多线程也是如此，但是比信号处理函数更加灵活，信号处理函数的控制流程只是在信号递达时产生，在处理完信号之后就结束，而多线程的控制流程可以长期并存，操作系统会在各线程之间调度和切换，就像在多个进程之间调度和切换一样。由于同一进程的多个线程共享同一地址空间，因此Text Segment、Data Segment都是共享的，如果定义一个函数，在各线程中都可以调用，如果定义一个全局变量，在各线程中都可以访问到，除此之外，各线程还共享以下进程资源和环境：</p>
<p>文件描述符表</p>
<p>每种信号的处理方式（SIG_IGN、SIG_DFL或者自定义的信号处理函数）</p>
<p>当前工作目录</p>
<p>用户id和组id</p>
<p>但有些资源是每个线程各有一份的：</p>
<p>线程id</p>
<p>上下文，包括各种寄存器的值、程序计数器和栈指针</p>
<p>栈空间</p>
<p>errno变量</p>
<p>信号屏蔽字</p>
<p>调度优先级</p>
<p>我们将要学习的线程库函数是由POSIX标准定义的，称为POSIX thread或者pthread。在Linux上线程函数位于libpthread共享库中，因此在编译时要加上-lpthread选项。</p>
<p>1. 创建线程</p>
<p><pre class="prettyprint linenums">#include &lt;pthread.h&gt;

int pthread_create(pthread_t *restrictthread,<br />
         constpthread_attr_t *restrict attr,<br />
         void*(*start_routine)(void*), void *restrict arg);</pre>
<p>返回值：成功返回0，失败返回错误号。以前学过的系统函数都是成功返回0，失败返回-1，而错误号保存在全局变量errno中，而pthread库的函数都是通过返回值返回错误号，虽然每个线程也都有一个errno，但这是为了兼容其它函数接口而提供的，pthread库本身并不使用它，通过返回值返回错误码更加清晰。</p>
<p>在一个线程中调用pthread_create()创建新的线程后，当前线程从pthread_create()返回继续往下执行，而新的线程所执行的代码由我们传给pthread_create的函数指针start_routine决定。start_routine函数接收一个参数，是通过pthread_create的arg参数传递给它的，该参数的类型为void *，这个指针按什么类型解释由调用者自己定义。start_routine的返回值类型也是void *，这个指针的含义同样由调用者自己定义。start_routine返回时，这个线程就退出了，其它线程可以调用pthread_join得到start_routine的返回值，类似于父进程调用wait(2)得到子进程的退出状态，稍后详细介绍pthread_join。</p>
<p>pthread_create成功返回后，新创建的线程的id被填写到thread参数所指向的内存单元。我们知道进程id的类型是pid_t，每个进程的id在整个系统中是唯一的，调用getpid(2)可以获得当前进程的id，是一个正整数值。线程id的类型是thread_t，它只在当前进程中保证是唯一的，在不同的系统中thread_t这个类型有不同的实现，它可能是一个整数值，也可能是一个结构体，也可能是一个地址，所以不能简单地当成整数用printf打印，调用pthread_self(3)可以获得当前线程的id。</p>
<p>attr参数表示线程属性，本章不深入讨论线程属性，所有代码例子都传NULL给attr参数，表示线程属性取缺省值。首先看一个简单的例子：</p>
<pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;string.h&gt;<br />
#include &lt;stdlib.h&gt;<br />
#include &lt;pthread.h&gt;<br />
#include &lt;unistd.h&gt;

pthread_t ntid;

void printids(const char *s)<br />
{<br />
         pid_t      pid;<br />
         pthread_t  tid;

         pid= getpid();<br />
         tid= pthread_self();<br />
         printf(&quot;%spid %u tid %u (0x%x)\n&quot;, s, (unsigned int)pid,<br />
                (unsigned int)tid, (unsigned int)tid);<br />
}

void *thr_fn(void *arg)<br />
{<br />
         printids(arg);<br />
         returnNULL;<br />
}

int main(void)<br />
{<br />
         interr;

         err= pthread_create(&amp;ntid, NULL, thr_fn, &quot;new thread: &quot;);<br />
         if(err != 0) {<br />
                   fprintf(stderr,&quot;can't create thread: %s\n&quot;, strerror(err));<br />
                   exit(1);<br />
         }<br />
         printids(&quot;mainthread:&quot;);<br />
         sleep(1);

         return0;<br />
}</pre>
<p><p>编译运行结果如下：</p>
<pre class="prettyprint linenums">main thread: pid 7398 tid 3084450496(0xb7d8fac0)<br />
new thread: pid 7398 tid 3084446608 (0xb7d8eb90)</pre>
<p><p>可知在Linux上，thread_t类型是一个地址值，属于同一进程的多个线程调用getpid(2)可以得到相同的进程号，而调用pthread_self(3)得到的线程号各不相同。</p>
<p>由于pthread_create的错误码不保存在errno中，因此不能直接用perror(3)打印错误信息，可以先用strerror(3)把错误码转换成错误信息再打印。</p>
<p>2. 终止线程</p>
<p>如果需要只终止某个线程而不终止整个进程，可以有三种方法：</p>
<p>从线程函数return。这种方法对主线程不适用，从main函数return相当于调用exit。</p>
<p>一个线程可以调用pthread_cancel终止同一进程中的另一个线程。</p>
<p>线程可以调用pthread_exit终止自己。</p>
<p>用pthread_cancel终止一个线程分同步和异步两种情况，比较复杂，本章不打算详细介绍，读者可以参考[APUE2e]。下面介绍pthread_exit的和pthread_join的用法。</p>
<pre class="prettyprint linenums">#include &lt;pthread.h&gt;<br />
void pthread_exit(void *value_ptr);</pre>
<p><p>value_ptr是void *类型，和线程函数返回值的用法一样，其它线程可以调用pthread_join获得这个指针。</p>
<p>需要注意，pthread_exit或者return返回的指针所指向的内存单元必须是全局的或者是用malloc分配的，不能在线程函数的栈上分配，因为当其它线程得到这个返回指针时线程函数已经退出了。</p>
<pre class="prettyprint linenums">#include &lt;pthread.h&gt;<br />
int pthread_join(pthread_t thread, void**value_ptr);</pre>
<p><p>返回值：成功返回0，失败返回错误号</p>
<p>调用该函数的线程将挂起等待，直到id为thread的线程终止。thread线程以不同的方法终止，通过pthread_join得到的终止状态是不同的，总结如下：</p>
<p>如果thread线程通过return返回，value_ptr所指向的单元里存放的是thread线程函数的返回值。</p>
<p>如果thread线程被别的线程调用pthread_cancel异常终止掉，value_ptr所指向的单元里存放的是常数PTHREAD_CANCELED。</p>
<p>如果thread线程是自己调用pthread_exit终止的，value_ptr所指向的单元存放的是传给pthread_exit的参数。</p>
<p>如果对thread线程的终止状态不感兴趣，可以传NULL给value_ptr参数。</p>
<p>看下面的例子 ：</p>
<p><pre class="prettyprint linenums">#include &lt;stdio.h&gt;<br />
#include &lt;stdlib.h&gt;<br />
#include &lt;pthread.h&gt;<br />
#include &lt;unistd.h&gt;

void *thr_fn1(void *arg)<br />
{<br />
         printf(&quot;thread1 returning\n&quot;);<br />
         return(void *)1;<br />
}

void *thr_fn2(void *arg)<br />
{<br />
         printf(&quot;thread2 exiting\n&quot;);<br />
         pthread_exit((void*)2);<br />
}

void *thr_fn3(void *arg)<br />
{<br />
         while(1){<br />
                   printf(&quot;thread3 writing\n&quot;);<br />
                   sleep(1);<br />
         }<br />
}

int main(void)<br />
{<br />
         pthread_t   tid;<br />
         void        *tret;

         pthread_create(&amp;tid,NULL, thr_fn1, NULL);<br />
         pthread_join(tid,&amp;tret);<br />
         printf(&quot;thread1 exit code %d\n&quot;, (int)tret);

         pthread_create(&amp;tid,NULL, thr_fn2, NULL);<br />
         pthread_join(tid,&amp;tret);<br />
         printf(&quot;thread2 exit code %d\n&quot;, (int)tret);

         pthread_create(&amp;tid,NULL, thr_fn3, NULL);<br />
         sleep(3);<br />
         pthread_cancel(tid);<br />
         pthread_join(tid,&amp;tret);<br />
         printf(&quot;thread3 exit code %d\n&quot;, (int)tret);

         return0;<br />
}</pre></p>
<p>运行结果是：</p>
<p><pre class="prettyprint linenums">thread 1 returning<br />
thread 1 exit code 1<br />
thread 2 exiting<br />
thread 2 exit code 2<br />
thread 3 writing<br />
thread 3 writing<br />
thread 3 writing<br />
thread 3 exit code -1</pre></p>
<p>可见在Linux的pthread库中常数PTHREAD_CANCELED的值是-1。可以在头文件pthread.h中找到它的定义：</p>
<p>#define PTHREAD_CANCELED ((void *) -1)一般情况下，线程终止后，其终止状态一直保留到其它线程调用pthread_join获取它的状态为止。但是线程也可以被置为detach状态，这样的线程一旦终止就立刻回收它占用的所有资源，而不保留终止状态。不能对一个已经处于detach状态的线程调用pthread_join，这样的调用将返回EINVAL。对一个尚未detach的线程调用pthread_join或pthread_detach都可以把该线程置为detach状态，也就是说，不能对同一线程调用两次pthread_join，或者如果已经对一个线程调用了pthread_detach就不能再调用pthread_join了。</p>
<p><pre class="prettyprint linenums">#include &lt;pthread.h&gt;<br />
int pthread_detach(pthread_t tid);</pre></p>
<p>返回值：成功返回0，失败返回错误号。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gxoo7q.html">GET请求参数为中文时乱码分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z113nn9.html">Sqlserver&lowbar;insert语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd46vd8.html">C&num;获取根目录的方法集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y1475q.html">poj 2505 A multiplication game（博弈）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z7m529.html">CSS3中更灵活的布局方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpz6pj9.html">好用的有多种样式的搜索界面创建UISearchBar</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pro3y8.html">玩转Spring MVC&lpar;五&rpar;----在spring中整合log4j</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gje1r09.html">&period;net 上传文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25mld3q.html">启动CDH的cloudera-scm-server报错Error&colon; JAVA&lowbar;HOME is not set and Java could not be found</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllvpg0q.html">Python Built-in Function 学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvpm2y8.html">cocos2d-x与UIKit混合编程实现半透明效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/963p2249.html">Letter Combinations of a Phone Number leetcode java</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj2ly08.html">Java用freemarker导出word</a>
		</li>
						<li><a href="https://www.batexi.com/a/8koomgrq.html">poj3073</a>
		</li>
						<li><a href="https://www.batexi.com/a/963m1r49.html">python中url解析 or url的base64编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxl607jq.html">C&num; 用tabcontrol实现窗体类似网页排版的显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44wyk3q.html">Jquery学习之路&lpar;三&rpar; 实现弹出层插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvdm20yq.html">怎样解决putty终端乱码的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qd57d279.html">Maven 排除依赖jar包</a>
		</li>
						<li><a href="https://www.batexi.com/a/967j4k48.html">javaSe-SimpleDateFormat</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qn1x4ex8.html">Hibernate 入门的第一个程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1grlj9.html">ios将一个项目完全导为另一个项目&lpar;tool&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok6lxp9.html">Redis源代码分析（三）---dict哈希结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxn3xvz8.html">Android四大组件&mdash;&mdash;Service</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wznkxq.html">如何实现数字lcd显示效果&lpar;原创&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1g64k9.html">NYOJ-104最大和</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn5606q.html">对相同id的input框的循环判断</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x41jg9.html">img图片元素下多余空白解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1glwz9.html">HTML5触摸屏touch事件使用介绍1</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd2x1r8.html">Linux学习&mdash;&mdash;环境变量设置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
